#pragma once
#define __FX_S1516_DOUBLE_H

typedef int fx_s1516;

#include <stdio.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define P2_16 65536.0f
#define e M_E
#define fx_s1516_PI M_PI
#define fx_s1516_INVERSE_PI 1/M_PI


extern double double_to_fx(double a);
extern double baselog(double a, double base);
extern double fx_s1516_add(double a, double b);
extern double fx_s1516_sub(double a, double b);
extern double fx_s1516_mul(double a, double b);
extern double fx_s1516_div(double a, double b);
extern double fx_s1516_sqrt(double a);
extern double fx_s1516_pow(double a, double b);
extern double fx_s1516_log(double a, double b);
extern double degree_to_radian(fx_s1516 a);
extern double fx_to_double(fx_s1516 a);
extern double fx_s1516_sin(double a);