﻿#include "fx_s1516_double.h"

#define fx_mul(a, b) ((a)*(b))

/*
Make first prototype fx_sXXYY_double.c with double and math.h
define macro fx_sXXYY_double.h program test.c
*/

int main()
{
    fx_s1516 a = 131072;
	fx_s1516 b = 65536;

    double fa = fx_to_double(a);
    double fb = fx_to_double(b);

    printf("a : %d b : %d fa : %lf fb : %lf\noriginal a : %lf original b : %lf\n\n", a, b, fa, fb, double_to_fx(fa), double_to_fx(fb));
    
	printf("Add  : %-15d %lf\n", a + b, fx_s1516_add(fa, fb));
    printf("Sub  : %-15d %lf\n", a - b, fx_s1516_sub(fa, fb));
    printf("Mul  : %-15lld %lf\n", (long long)a * b, fx_s1516_mul(fa, fb));
    printf("Div  : %-15lf %lf\n\n", (double)a / b, fx_s1516_div(fa, fb));
    
    printf("Sin  : %-15lf %lf\n", sin(degree_to_radian(a)), fx_s1516_sin(degree_to_radian(fa)));
    printf("Sqrt : %-15lf %lf\n", sqrt(a), fx_s1516_sqrt(fa));
    printf("Sqrt : %-15lf %lf\n", sqrt(b), fx_s1516_sqrt(fb));
    printf("Pow  : %-15lld %lf\n", (long long)pow(a, 2), fx_s1516_pow(fa, 2));
    printf("Log  : %-15lf %lf\n\n", baselog(a, e), fx_s1516_log(fa, e));

    printf("PI : %f\n", fx_s1516_PI);
    printf("INVERSE PI : %f\n", fx_s1516_INVERSE_PI);
}
